__author__ = 'nicr'
import subprocess
import uuid
import shutil
import sys
from Rutility import *

if len(sys.argv) != 3:
    print "illegal arguments"
    exit(-1)

PATH=sys.argv[1]
HDFS_PATH=sys.argv[2]
SEP='\\'

echoFile(os.path.normcase(PATH + SEP + 'jobIdDebug.txt'), '=== run-r.sh ===', 'a')

touch(PATH + SEP + 'lastOutputBlock.txt')

MYUUID=uuid.uuid4()

fname = os.path.normcase(PATH + SEP + str(MYUUID))
echoFile(fname, 'queued', 'w')

shutil.move(fname, os.path.normcase(PATH +  SEP + 'jobStatus.txt'))

echoFile(os.path.normcase(PATH +  SEP + 'jobIdentifier.txt'), 'uninitialized', 'w')

CREATE_NEW_PROCESS_GROUP = 0x00000200

output = PATH + SEP + "MergedOut0.txt"
f = open(output, "w")

proc = subprocess.Popen("R.exe -e library(RevoScaleR);rxRemoteHadoopMRCall() --no-restore --no-save -q  --args rxCommArgs(rxComputeWhere='masterNode',rxNetworkShareJobDirectory='" \
                        + PATH.replace('\\', '\\\\') + "',rxClusterTarget='hadoopmr',rxTraceLevel=0,rxCommType='HadoopMR_JP') ", \
                        creationflags=CREATE_NEW_PROCESS_GROUP, stderr=f, stdout=f) #stderr=sys.stdout ,stdout=sys.stdout)
MYPID = proc.pid

echoFile(os.path.normcase(PATH +  SEP + 'jobIdDebug.txt'), 'MYPID = ' + str(MYPID), 'a')

time.sleep(1)

p = pgrep("R.exe")
MY_TEST_PID = grep(MYPID,p)

echoFile(os.path.normcase(PATH +  SEP + 'jobIdentifier.txt'), MY_TEST_PID, 'w')

NUMCHARS = wc(os.path.normcase(PATH +  SEP + 'jobIdentifier.txt'), '-m')

COUNTER=0
if NUMCHARS > 1 :
    COUNTER=9999
else:
    echoFile(os.path.normcase(PATH +  SEP + 'jobIdentifier.txt'), COUNTER, 'a')
    COUNTER=COUNTER + 1

if COUNTER != 9999 :
    echoFile(os.path.normcase(PATH +  SEP + 'jobIdDebug.txt'), 'Unable to find process ID', 'a')
    echoFile(os.path.normcase(PATH +  SEP + 'jobIdentifier.txt'), '', 'w')
    echoFile(os.path.normcase(PATH +  SEP + 'jobStatus.txt'), 'failed', 'w')
time.sleep(1)
 
