# For saving time, hpa result preparer does not need to load RevoScaleR package.
args <- commandArgs(trailingOnly = TRUE)

result.dir <- args[1]
out.data.name <- args[2]

func <- function(outputDir, froFileName)
{
    retEnv <- new.env(hash = TRUE)
    filePath <- file.path(outputDir, froFileName)
    outputObjectName <- load(filePath, envir = retEnv)
    retObject <- get(outputObjectName, envir = retEnv)
    return(retObject)
}

funcParams <- list(froFileName = out.data.name)

jobObject <- list(func = func, funcParams = funcParams)
save(jobObject, file = file.path(result.dir, "job.ROutData"))
