__author__ = 'nicr'
import subprocess
import os.path
import time
import re
import uuid
import shutil
from Rutility import *

if len(sys.argv) != 2:
    print "illegal arguments"
    exit(-1)

PATH=sys.argv[1]
SEP='\\'

if os.path.exists(os.path.normcase(PATH + SEP + "jobStatus.txt")):
    print("File exists")
    with open(os.path.normcase(PATH + SEP + "jobStatus.txt"), "r") as content_file:
        MYSTATE = content_file.read().replace('\n', '')
        print("content of file = ",MYSTATE)
        if (MYSTATE ==  "canceled" ) or ( MYSTATE == "finished" ) or ( MYSTATE == "failed" ):
            exit()

if os.path.exists(os.path.normcase(PATH + SEP + "MergedOut0.txt")):
    t = tail(os.path.normcase(PATH + SEP + 'MergedOut0.txt'),1,True)
    JOBID = grep("Running job:",t)
    if (not JOBID is None):
        index = JOBID.find("job_")
        JOBID = JOBID[index:].strip(' \t\n\r')

proc = subprocess.Popen("hadoop job -list all" , stdout=subprocess.PIPE, shell=True)
JOBSTATE = proc.communicate()[0]
ret = proc.returncode

JOBSTATE = grep(JOBID,JOBSTATE.splitlines())
JOBSTATE = JOBSTATE.split()[1]
MYUUID=uuid.uuid4()
fname = os.path.normcase(PATH + SEP + str(MYUUID))
echoFile(fname, 'undetermined', 'w')
shutil.move(fname, os.path.normcase(PATH +  SEP + 'jobStatus.txt'))

if (JOBSTATE ==  "1" ) or ( JOBSTATE == "RUNNING" ):
    MYUUID=uuid.uuid4()
    fname = os.path.normcase(PATH + SEP + str(MYUUID))
    echoFile(fname, 'running', 'w')
    shutil.move(fname, os.path.normcase(PATH +  SEP + 'jobStatus.txt'))

if (JOBSTATE ==  "2" ) or ( JOBSTATE == "SUCCEEDED" ):
    MYUUID=uuid.uuid4()
    fname = os.path.normcase(PATH + SEP + str(MYUUID))
    echoFile(fname, 'finished', 'w')
    shutil.move(fname, os.path.normcase(PATH +  SEP + 'jobStatus.txt'))

if (JOBSTATE ==  "3" ) or ( JOBSTATE == "FAILED" ):
    MYUUID=uuid.uuid4()
    fname = os.path.normcase(PATH + SEP + str(MYUUID))
    echoFile(fname, 'failed', 'w')
    shutil.move(fname, os.path.normcase(PATH +  SEP + 'jobStatus.txt'))

if (JOBSTATE ==  "4" ) or ( JOBSTATE == "PREP" ):
    MYUUID=uuid.uuid4()
    fname = os.path.normcase(PATH + SEP + str(MYUUID))
    echoFile(fname, 'queued', 'w')
    shutil.move(fname, os.path.normcase(PATH +  SEP + 'jobStatus.txt'))

if (JOBSTATE ==  "5" ) or ( JOBSTATE == "KILLED" ):
    MYUUID=uuid.uuid4()
    fname = os.path.normcase(PATH + SEP + str(MYUUID))
    echoFile(fname, 'canceled', 'w')
    shutil.move(fname, os.path.normcase(PATH +  SEP + 'jobStatus.txt'))


