args<-commandArgs(trailingOnly = TRUE)

outputIROPath <- args[1]
inputIROPrefix <- args[2]
numIros <- as.numeric(args[3])

outDataFinal <- list()

for (iroId in seq(0, numIros - 1))
{
    outDataPath <- paste0(inputIROPrefix, iroId, ".iro")
    objectName <- load(outDataPath)
    outData <- get(objectName)
    outDataFinal <- c(outDataFinal, outData)
}

outData <- outDataFinal
save(outData, file = outputIROPath)
