# For saving time, Hpc reducer does not need to load RevoScaleR package.
args <- commandArgs(trailingOnly = TRUE)

fro <- args[1]
work.dir <- args[2]

outputDirContents <- dir(work.dir)
goodOutputFileLocations <- grep("rxElem.*ROutData", outputDirContents)
numOutputObjects <- length(goodOutputFileLocations)

i <- 1L
clusterOutputList <- list()
while( i <= numOutputObjects )
{
  outputFileName <- outputDirContents[[goodOutputFileLocations[[i]]]]
  outputObjectName <- load( file.path(work.dir, outputFileName ) )

  legalRCompBasedVarName <-gsub( "-", "_",  outputFileName )
  legalRCompBasedVarName <- gsub( ".ROutData", "", legalRCompBasedVarName )

  if ( isTRUE(TRUE %in% as.logical(grep("^rxElem", legalRCompBasedVarName))))
  {
    while( isTRUE(TRUE %in% as.logical(grep("m0",legalRCompBasedVarName))))
    {
      legalRCompBasedVarName<-gsub("m0","m",legalRCompBasedVarName)
    }
  }
  tmpList <- list( x = get(outputObjectName) )
  names( tmpList ) <- legalRCompBasedVarName

  clusterOutputList[legalRCompBasedVarName] <- tmpList
  i <- i + 1L
}
save(clusterOutputList, file = fro)
