"test.doJSON.check" <- function()
{
    library(RevoScaleR)

    iris.sub <- c(sample(1:50, 25), sample(51:100, 25), sample(101:150, 25))
    iris.dtree <- rxDTree(Species ~ Sepal.Length + Sepal.Width + Petal.Length + Petal.Width, data = iris[iris.sub, ])
    zz <- createTreeView(iris.dtree)

    checkEquals("revoTreeView", class(zz)[1])

    checkEquals(1, grep("\\{\\{DATA\\}\\}",zz$html))
    checkEquals(1, grep("dtree",zz$html))
    
    checkEquals(1, grep("method",zz$json))
    checkEquals(1, grep("class",zz$json))
    checkEquals(1, grep("summary",zz$json))
    checkEquals(1, grep("legend",zz$json))
    checkEquals(1, grep("depVars",zz$json))
    checkEquals(1, grep("indVars",zz$json))
    checkEquals(1, grep("split",zz$json))
    checkEquals(1, grep("children",zz$json))
    checkEquals(1, grep("leaf",zz$json))
}
